# Library

---

```@meta
CurrentModule = RigorousInvariantMeasures
```

## Contractors
These are interval contractors implemented here; in the future they may be substituted by established libraries, as [IntervalRootFinding.jl]()
```@autodocs
Modules = [Base, 
            RigorousInvariantMeasures, 
            RigorousInvariantMeasures.Contractors]
Pages = ["Contractors.jl"]
```

## Preimages
Optimized methods to compute preimages of ``1`` dimensional maps.

```@autodocs
Modules = [Base, 
            RigorousInvariantMeasures, 
            RigorousInvariantMeasures.DynamicDefinition]
Pages = ["preimages.jl"]
```



## Index

```@index
Pages = ["basis.md", "api.md", "dynamic.md"]
Modules = [RigorousInvariantMeasures]
Order = [:type, :function]
```
